'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RESULT_FUNCTION_NAME = '___RESULT_FUNCTION';

var ChainObject = function () {
  function ChainObject(target, options) {
    _classCallCheck(this, ChainObject);

    var defaults = {
      debug: false
    };
    this.target = target;
    this.options = Object.assign(defaults, options);
    this.actions = [];
  }

  _createClass(ChainObject, [{
    key: 'addAction',
    value: function addAction(name, args) {
      this.actions.push({ name: name, args: args });
    }
  }, {
    key: 'end',
    value: function end() {
      var result, actions, idx, action;
      return regeneratorRuntime.async(function end$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              result = null;
              actions = Object.assign({}, this.actions);

              this.actions = [];
              _context.prev = 3;
              _context.t0 = regeneratorRuntime.keys(actions);

            case 5:
              if ((_context.t1 = _context.t0()).done) {
                _context.next = 20;
                break;
              }

              idx = _context.t1.value;
              action = actions[idx];

              if (this.options.debug) {
                console.log('[async-chain-proxy] execute \'' + action.name + '\'');
              }

              if (!(RESULT_FUNCTION_NAME === action.name)) {
                _context.next = 15;
                break;
              }

              _context.next = 12;
              return regeneratorRuntime.awrap(action.args[0].apply(null, [result]));

            case 12:
              result = _context.sent;
              _context.next = 18;
              break;

            case 15:
              _context.next = 17;
              return regeneratorRuntime.awrap(this.target[action.name].apply(this.target, action.args));

            case 17:
              result = _context.sent;

            case 18:
              _context.next = 5;
              break;

            case 20:
              _context.next = 26;
              break;

            case 22:
              _context.prev = 22;
              _context.t2 = _context['catch'](3);

              if (this.options.debug) {
                console.log(_context.t2);
              }
              throw _context.t2;

            case 26:
              return _context.abrupt('return', result);

            case 27:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this, [[3, 22]]);
    }
  }]);

  return ChainObject;
}();

function makeHandler(target, options) {
  return {
    get: function get(chainObj, name) {
      if (name === options.endFuncName) {
        return function () {
          return chainObj.end(chainObj, arguments).then(function (result) {
            if (options.onChainFinished) {
              options.onChainFinished(target);
            }
            return result;
          }).catch(function (e) {
            if (options.debug) {
              console.log(e);
            }
            throw e;
          });
        };
      } else if (name === options.resultFuncName) {
        return function () {
          chainObj.addAction(RESULT_FUNCTION_NAME, arguments);
          return this;
        };
      } else if (name === 'target') {
        return target;
      } else if (typeof target[name] === 'function') {
        return function () {
          chainObj.addAction(name, arguments);
          return this;
        };
      } else if (name in target) {
        return target[name];
      } else {
        throw new Error('\'' + name + '\' is not defined on a target object.');
      }
    },
    set: function set(chainObj, name, value) {
      throw new Error('You cannot set a value to Proxy object.');
    }
  };
}

function createChainObject(target) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var defaultParams = {
    debug: false,
    resultFuncName: 'result',
    endFuncName: 'end',
    onChainFinished: null
  };
  options = Object.assign(defaultParams, options);
  var chainObject = new ChainObject(target, options);
  return new Proxy(chainObject, makeHandler(target, options));
}

module.exports = createChainObject;
//# sourceMappingURL=index.js.map